package cn.iocoder.yudao.module.inspection.service.impl;

import java.util.List;

import cn.hutool.core.util.ObjectUtil;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import cn.iocoder.yudao.util.DateUtils;
import cn.iocoder.yudao.module.inspection.entity.InspectionNewsAssociation;
import cn.iocoder.yudao.module.inspection.mapper.InspectionNewsAssociationMapper;
import cn.iocoder.yudao.module.inspection.service.IInspectionNewsAssociationService;
import org.springframework.stereotype.Service;


/**
 * 【请填写功能名称】Service业务层处理
 *
 * @author ruoyi
 * @date 2023-08-07
 */
@Service
public class InspectionNewsAssociationServiceImpl extends ServiceImpl<InspectionNewsAssociationMapper, InspectionNewsAssociation> implements IInspectionNewsAssociationService
{

    /**
     * 查询【请填写功能名称】
     *
     * @param id 【请填写功能名称】主键
     * @return 【请填写功能名称】
     */
    @Override
    public InspectionNewsAssociation selectInspectionNewsAssociationById(Long id)
    {
        return baseMapper.selectInspectionNewsAssociationById(id);
    }

    /**
     * 查询【请填写功能名称】列表
     *
     * @param inspectionNewsAssociation 【请填写功能名称】
     * @return 【请填写功能名称】
     */
    @Override
    public IPage<InspectionNewsAssociation> selectInspectionNewsAssociationList(Page<InspectionNewsAssociation> page, InspectionNewsAssociation inspectionNewsAssociation)
    {
        return baseMapper.selectInspectionNewsAssociationList(page,inspectionNewsAssociation);
    }

    /**
     * 新增【请填写功能名称】
     *
     * @param inspectionNewsAssociation 【请填写功能名称】
     * @return 结果
     */
    @Override
    public int insertInspectionNewsAssociation(InspectionNewsAssociation inspectionNewsAssociation)
    {
        return baseMapper.insertInspectionNewsAssociation(inspectionNewsAssociation);
    }

    /**
     * 修改【请填写功能名称】
     *
     * @param inspectionNewsAssociation 【请填写功能名称】
     * @return 结果
     */
    @Override
    public int updateInspectionNewsAssociation(InspectionNewsAssociation inspectionNewsAssociation)
    {
        inspectionNewsAssociation.setUpdateTime(DateUtils.getNowDate());
        return baseMapper.updateInspectionNewsAssociation(inspectionNewsAssociation);
    }

    /**
     * 批量删除【请填写功能名称】
     *
     * @param ids 需要删除的【请填写功能名称】主键
     * @return 结果
     */
    @Override
    public int deleteInspectionNewsAssociationByIds(Long[] ids)
    {
        return baseMapper.deleteInspectionNewsAssociationByIds(ids);
    }

    /**
     * 删除【请填写功能名称】信息
     *
     * @param id 【请填写功能名称】主键
     * @return 结果
     */
    @Override
    public int deleteInspectionNewsAssociationById(Long id)
    {
        return baseMapper.deleteInspectionNewsAssociationById(id);
    }

    @Override
    public Long getStatus(Long newsId, Long userId,String type) {
        LambdaQueryWrapper<InspectionNewsAssociation> queryWrapper =new LambdaQueryWrapper<>();
        queryWrapper.eq(InspectionNewsAssociation::getNewsId,newsId)
                    .eq(InspectionNewsAssociation::getUserId,userId)
                    .eq(InspectionNewsAssociation::getType,type);
        InspectionNewsAssociation inspectionNewsAssociation = baseMapper.selectOne(queryWrapper);
        if (ObjectUtil.isEmpty(inspectionNewsAssociation)){
            return null;
        }
        return inspectionNewsAssociation.getId();
    }
}
